function priklad4
clf;
M=40; N=20; x1=linspace(0,2*pi,M)'*ones(1,N); x2=ones(M,1)*linspace(0,2*pi,N);
[y1,y2,y3]=F(x1,x2); mesh(y1,y2,y3,'facecolor','w','edgecolor','k');
axis equal; axis vis3d; axis manual; hold on
xx1=3; xx2=.5;
[yy1,yy2,yy3]=F(xx1,xx2); plot3(yy1,yy2,yy3,'ro');
[y1,y2,y3]=T1(xx1,xx2,x1,x2); mesh(y1,y2,y3,'facecolor','w','edgecolor','g');
[y1,y2,y3]=T2(xx1,xx2,x1,x2); mesh(y1,y2,y3,'facecolor','w','edgecolor','b');
return

function [y1,y2,y3]=F(x1,x2)
    R=2; r=1;
    y1=(R+r*cos(x2)).*cos(x1);
    y2=(R+r*cos(x2)).*sin(x1);
    y3=r*sin(x2);

function [y1,y2,y3]=T1(xx1,xx2,x1,x2)
    r=1;R=2;
    [y1t,y2t,y3t] = F(xx1,xx2);
    y1=y1t - (R+r*cos(xx2))*sin(xx1).*(x1-xx1)-r*cos(xx1)*sin(xx2).*(x2-xx2);
    y2=y2t + (R+r*cos(xx2))*cos(xx1).*(x1-xx1)-r*cos(xx1)*sin(xx2).*(x2-xx2);
    y3=y3t + r*cos(xx2).*(x2-xx2);

function [y1,y2,y3]=T2(xx1,xx2,x1,x2)
    r=1;R=2;
    
    %% Prvni chyba je zde
    %[y1t,y2t,y3t] = T1(xx1,xx1,x1,x2);
    
    % toto je spravne
    [y1t,y2t,y3t] = T1(xx1,xx2,x1,x2);
    
    %% vypocet Hessianu je OK
    ddy1 = [-(R+r*cos(xx2))*cos(xx1) r*sin(xx1)*sin(xx2);
            r*sin(xx1)*sin(xx2) -r*cos(xx1)*cos(xx2)];
    ddy2 = [-(R+r*cos(xx2))*sin(xx1) -r*cos(xx1)*sin(xx2);
           -r*cos(xx1)*sin(xx2) -r*cos(xx2)*sin(xx1)];
    ddy3 = [0  0;
           0 -r*sin(xx2)];
       
    %% Druha chyba je nekde zde
    %ddty1 = [(x1-xx1).*ddy1(1,1)+(x2-xx2).*ddy1(2,1) (x1-xx1).*ddy1(1,2)+(x2-xx2).*ddy1(2,2)];
    %ddty2 = [(x1-xx1).*ddy2(1,1)+(x2-xx2).*ddy2(2,1) (x1-xx1).*ddy2(1,2)+(x2-xx2).*ddy2(2,2)];
    %ddty3 = [(x1-xx1).*ddy3(1,1)+(x2-xx2).*ddy3(2,1) (x1-xx1).*ddy3(1,2)+(x2-xx2).*ddy3(2,2)];
    %y1 = y1t + 0.5*((x1-xx1).*ddty1(1) + (x2-xx2).*ddty1(2));
    %y2 = y2t + 0.5*((x1-xx1).*ddty2(1) + (x2-xx2).*ddty2(2));
    %y3 = y3t + 0.5*((x1-xx1).*ddty3(1) + (x2-xx2).*ddty3(2));
    
    % toto je jedno spravne    
    y1 = y1t + reshape(0.5*  sum([x1(:)'-xx1; x2(:)'-xx2].*(ddy1*[x1(:)'-xx1; x2(:)'-xx2])), size(x1,1), size(x1,2));
    y2 = y2t + reshape(0.5*  sum([x1(:)'-xx1; x2(:)'-xx2].*(ddy2*[x1(:)'-xx1; x2(:)'-xx2])), size(x1,1), size(x1,2));
    y3 = y3t + reshape(0.5*  sum([x1(:)'-xx1; x2(:)'-xx2].*(ddy3*[x1(:)'-xx1; x2(:)'-xx2])), size(x1,1), size(x1,2));
    